Package org.apache.sysds.runtime.ooc.stream

# Class SourceOOCStream

java.lang.Object
org.apache.sysds.runtime.controlprogram.parfor.LocalTaskQueue<OOCStream.QueueCallback<T>>
org.apache.sysds.runtime.instructions.ooc.SubscribableTaskQueue<IndexedMatrixValue>
org.apache.sysds.runtime.ooc.stream.SourceOOCStream

All Implemented Interfaces:
  `OOCStream<IndexedMatrixValue>`, `OOCStreamable<IndexedMatrixValue>`

public class SourceOOCStream extends SubscribableTaskQueue<IndexedMatrixValue>

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`SourceOOCStream.SourceGroupCallback`

## Nested classes/interfaces inherited from interface org.apache.sysds.runtime.instructions.ooc.OOCStream

`OOCStream.GroupQueueCallback<T>, OOCStream.QueueCallback<T>, OOCStream.SimpleQueueCallback<T>`

## Field Summary

### Fields inherited from class org.apache.sysds.runtime.controlprogram.parfor.LocalTaskQueue

`MAX_SIZE, NO_MORE_TASKS`

## Constructor Summary

Constructors
Constructor
Description
`SourceOOCStream()`

## Method Summary

Modifier and Type
Method
Description
`void`
`enqueue(IndexedMatrixValue val)`
`void`
`enqueue(IndexedMatrixValue value, OOCIOHandler.SourceBlockDescriptor descriptor)`
`void`
`enqueueGroup(List<IndexedMatrixValue> values, OOCIOHandler.GroupSourceBlockDescriptor descriptor)`
`OOCIOHandler.SourceBlockDescriptor`
`getDescriptor(MatrixIndexes indexes)`
`void`
`messageUpstream(OOCStreamMessage msg)`

### Methods inherited from class org.apache.sysds.runtime.instructions.ooc.SubscribableTaskQueue

`addDownstreamMessageRelay, addUpstreamMessageRelay, clearDownstreamMessageRelays, clearUpstreamMessageRelays, closeInput, dequeue, dequeueCB, dequeueTask, enqueue, enqueueTask, getData, getDataCharacteristics, getReadStream, getStreamCache, getWriteStream, hasStreamCache, messageDownstream, propagateFailure, setData, setDownstreamMessageRelay, setIXTransform, setSubscriber, setUpstreamMessageRelay, toString`

### Methods inherited from class org.apache.sysds.runtime.controlprogram.parfor.LocalTaskQueue

`hasNext, isProcessed`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.sysds.runtime.instructions.ooc.OOCStreamable

`isProcessed`

## Constructor Details

### SourceOOCStream

public SourceOOCStream()

## Method Details

### enqueue

public void enqueue(IndexedMatrixValue value, OOCIOHandler.SourceBlockDescriptor descriptor)

### enqueueGroup

public void enqueueGroup(List<IndexedMatrixValue> values, OOCIOHandler.GroupSourceBlockDescriptor descriptor)

### enqueue

public void enqueue(IndexedMatrixValue val)

Specified by:
  `enqueue` in interface `OOCStream<IndexedMatrixValue>`
Overrides:
  `enqueue` in class `SubscribableTaskQueue<IndexedMatrixValue>`

### getDescriptor

public OOCIOHandler.SourceBlockDescriptor getDescriptor(MatrixIndexes indexes)

### messageUpstream

public void messageUpstream(OOCStreamMessage msg)

Specified by:
  `messageUpstream` in interface `OOCStreamable<IndexedMatrixValue>`
Overrides:
  `messageUpstream` in class `SubscribableTaskQueue<IndexedMatrixValue>`